import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.Hashtable;
import javax.swing.BorderFactory;
import javax.swing.border.*;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

class AboutDlg extends JFrame {
	
}

public class algen extends JFrame implements ActionListener
{
	JMenuBar grayMenuBar;
	JToolBar toolBar;
	JPanel toolPanel;
       	ImagePanel aqua;
	JLabel statusLabel;
	
	GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
         	
	String[] Test={"sdf","hgff","gfhCV"};

	JComboBox AlgList = new JComboBox(Test);
        
        Timer timer;
        int x=0;
        int y=0;

	int SimulationDelay=50;
        boolean Running = false; 
                          	
        ImageIcon OpenRolloverImg=new ImageIcon("images/OpenImgOver.gif");
        ImageIcon SaveRolloverImg=new ImageIcon("images/SaveImgOver.gif");
        ImageIcon OpenImg=new ImageIcon("images/OpenImg.gif");
        ImageIcon SaveImg=new ImageIcon("images/SaveImg.gif");

        JSlider SpeedSlider;
        JSlider LightSlider;
 
        Toolkit toolkit = Toolkit.getDefaultToolkit();
        Image AlgUp=toolkit.getImage("images/al_up.gif");
        Image AlgDown=toolkit.getImage("images/al_down.gif");
        Image AlgLeft=toolkit.getImage("images/al_left.gif");
        Image AlgRight=toolkit.getImage("images/al_right.gif");

        Container contentPane = getContentPane();
       
        JMenu FileMenu = new JMenu("File");
       
        JMenuItem LoadConfigMenuItem = new JMenuItem("Load config",KeyEvent.VK_L);
        JMenuItem SaveConfigAsMenuItem = new JMenuItem("Save config as...",KeyEvent.VK_A);
        JMenuItem LoadStateMenuItem = new JMenuItem("Load state",KeyEvent.VK_T);
        JMenuItem SaveStateAsMenuItem = new JMenuItem("Save state as...",KeyEvent.VK_S);
        JMenuItem SaveStateMenuItem = new JMenuItem("Save state",KeyEvent.VK_V);
        JMenuItem ResetMenuItem = new JMenuItem("Reset",KeyEvent.VK_R);
        JMenuItem QuitMenuItem=new JMenuItem("Quit ALGAE",KeyEvent.VK_Q);
        
     	JMenu WindowMenu=new JMenu("Windows");
       	JMenuItem InfoItem = new JMenuItem("Info window", KeyEvent.VK_I);
        JMenu HelpMenu=new JMenu("Help");
       	JMenuItem HelpTopicsMenuItem = new JMenuItem("Topics", KeyEvent.VK_T);
        JMenuItem HelpAboutMenuItem=new JMenuItem("About ALGAE", KeyEvent.VK_A);
	
        JButton NewButton=new JButton(new ImageIcon("images/NewImg.gif"));
        JButton OpenButton=new JButton(OpenImg);                
        JButton SaveButton=new JButton(SaveImg);
        JButton PlayButton=new JButton(new ImageIcon("images/PlayImg.gif"));
	JButton PauseButton=new JButton(new ImageIcon("images/PauseImg.gif"));
        JButton StepButton=new JButton(new ImageIcon("images/StepImg.gif"));
        JButton ResetButton=new JButton(new ImageIcon("images/ResetImg.gif"));
        JButton HelpButton=new JButton(new ImageIcon("images/HelpImg.gif"));
  	JButton ZoomInButton=new JButton(new ImageIcon("images/ZoomIn.gif"));
  	JButton ZoomOutButton=new JButton(new ImageIcon("images/ZoomOut.gif"));

	JCheckBox NoDisplayCB=new JCheckBox("Display ON/OFF");
  	JCheckBox DayNightCB=new JCheckBox("Day/Night cycle");
        JCheckBox DummyCB = new JCheckBox("Dummy");
	
  	public void AddMenuItems()
        {
        	// add Simulation menu
		FileMenu.setMnemonic(KeyEvent.VK_F);
          	grayMenuBar.add(FileMenu);
          	
          	// items of the Simulation menu
          	FileMenu.add(LoadConfigMenuItem);
		FileMenu.add(SaveConfigAsMenuItem);
		FileMenu.add(LoadStateMenuItem);
		FileMenu.add(SaveStateAsMenuItem);
		FileMenu.add(SaveStateMenuItem);
		FileMenu.addSeparator();
		FileMenu.add(ResetMenuItem);
		FileMenu.addSeparator();
          	FileMenu.add(QuitMenuItem);         
		QuitMenuItem.addActionListener(this);
		
		// add windows menu
		WindowMenu.setMnemonic(KeyEvent.VK_W);
		grayMenuBar.add(WindowMenu);
		
		// add items for windows menu
		WindowMenu.addSeparator();
          	WindowMenu.add(InfoItem);         
		
		// add Help menu
		HelpMenu.setMnemonic(KeyEvent.VK_H);
		grayMenuBar.add(HelpMenu);
			
		// items of the Help menu
          	HelpMenu.add(HelpTopicsMenuItem); 
          	HelpMenu.addSeparator();
		HelpMenu.add(HelpAboutMenuItem);          	                  
        }	

        public void actionPerformed(ActionEvent e)
        {
	    Object src=e.getSource();
	    if (src==QuitMenuItem)
		{
		    //Custom button text
		    Object[] options = {"Yes","No",};
                    int result = JOptionPane.showOptionDialog(this,
                        "Do you really like to quit ALGAE ? ",
                        "Confirmation",
                        JOptionPane.YES_NO_OPTION,
                        JOptionPane.QUESTION_MESSAGE,
                        null,
                        options,
                        options[1]);
		    if (result==JOptionPane.YES_OPTION)
			System.exit(0);		
		}
	    if ((src==PlayButton) && (!Running))
	    {
	    	System.out.println("Play button pressed...");
	    	Running=true;
	    	timer.start();
		ChangeStatusBar("Simulation runnning...");
	    }
	    if ((src==PauseButton) && (Running))
	    {
	    	System.out.println("Pause button pressed...");
	    	Running=false;
	    	timer.stop();
		ChangeStatusBar("Simulation stopped...");
	    }
	    if ((src==StepButton) && (!Running))
	    {
	    	System.out.println("Step-Button button pressed...");
		ChangeStatusBar("Single step done...");
	    }
	}
                 
        public void AddToolBarButtons()
        {
        	NewButton.setToolTipText("Start new simulation");
        	toolBar.add(NewButton);

                OpenButton.setPressedIcon(OpenRolloverImg);
                OpenButton.setRolloverIcon(OpenRolloverImg);
                OpenButton.setRolloverEnabled(true);
                OpenButton.setToolTipText("Open a simulation file");
        	toolBar.add(OpenButton);

                SaveButton.setPressedIcon(SaveRolloverImg);
                SaveButton.setRolloverIcon(SaveRolloverImg);
                SaveButton.setRolloverEnabled(true);
        	SaveButton.setToolTipText("Save current simulation file");
        	toolBar.add(SaveButton);
        	
        	toolBar.addSeparator();
	
		PlayButton.addActionListener(this);
         	PlayButton.setToolTipText("Start/continue simulation");
        	toolBar.add(PlayButton);
         	PauseButton.addActionListener(this);
        	PauseButton.setToolTipText("Pause simulation");
        	toolBar.add(PauseButton);
        	StepButton.addActionListener(this);
        	StepButton.setToolTipText("Simulate single step");
        	toolBar.add(StepButton);
        	ResetButton.addActionListener(this);
        	ResetButton.setToolTipText("Reset simulation");
        	toolBar.add(ResetButton);
        	
        	toolBar.addSeparator();
        	/*
        	HelpButton.setToolTipText("Open online help");
        	toolBar.add(HelpButton);
                toolBar.addSeparator();
                */
        	ZoomInButton.setToolTipText("Zoom in aquarium view");
        	toolBar.add(ZoomInButton);
                ZoomOutButton.setToolTipText("Zoom out aquarium view");
        	toolBar.add(ZoomOutButton);
                toolBar.addSeparator();
      	}

        public void AddSliders()
        {
                SpeedSlider = new JSlider(JSlider.HORIZONTAL,0, 50, SimulationDelay);
		SpeedSlider.addChangeListener(new SliderListener());
		SpeedSlider.setMajorTickSpacing(25);
		SpeedSlider.setMinorTickSpacing(10);
		SpeedSlider.setPaintTicks(true);
		SpeedSlider.setPaintLabels(true);

		JLabel SpeedLabel = new JLabel("Simulation Speed", JLabel.CENTER);
        	SpeedLabel.setAlignmentX(Component.CENTER_ALIGNMENT);

		Hashtable SpeedLabelTable = new Hashtable();
          	SpeedLabelTable.put( new Integer( 0 ), new JLabel("Fast") );
          	SpeedLabelTable.put( new Integer( 50 ), new JLabel("Slow") );
          	SpeedSlider.setLabelTable(SpeedLabelTable);
          	SpeedSlider.setBorder(BorderFactory.createEmptyBorder(0,0,10,0));
                
               	LightSlider = new JSlider(JSlider.HORIZONTAL,0, 100, 100);
		//LightSlider.addChangeListener(new SliderListener());
		LightSlider.setMajorTickSpacing(50);
		LightSlider.setMinorTickSpacing(20);
		LightSlider.setPaintTicks(true);
		LightSlider.setPaintLabels(true);
		
		//Create the label table
          	Hashtable LightLabelTable = new Hashtable();
          	LightLabelTable.put( new Integer( 0 ), new JLabel("Dark") );
          	LightLabelTable.put( new Integer( 100 ), new JLabel("Bright") );
          	LightSlider.setLabelTable( LightLabelTable );
				
		LightSlider.setBorder(BorderFactory.createEmptyBorder(0,0,10,0)); 
		JPanel tmp = new JPanel(new GridLayout(1,2));
		tmp.add(LightSlider);
		tmp.add(SpeedSlider);

		c.gridx = 0;
         	c.gridy = 1;
         	c.gridwidth=6;
         	c.gridheight=1;
         	c.weightx=1;
         	c.weighty=0;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.HORIZONTAL;
         	gridbag.setConstraints(tmp, c);
         				
		contentPane.add(tmp);
                                
        }
        
        public void AddCBS()
        {
	        TitledBorder graphborder= BorderFactory.createTitledBorder(BorderFactory.createLoweredBevelBorder(), "Options");
	        JPanel tmp = new JPanel(new GridLayout(3,1));
                
        	tmp.add(NoDisplayCB);
         	tmp.add(DayNightCB);
		tmp.add(DummyCB);
         	// add "day night cycle" checkbox
        	c.gridx = 6;
         	c.gridy = 0;
         	c.gridwidth=3;
         	c.gridheight=2;
         	c.weightx=1;
         	c.weighty=0;
         	c.insets=new Insets(0,10,0,0);
         	c.fill = GridBagConstraints.HORIZONTAL;
         	gridbag.setConstraints(tmp, c);
		tmp.setBorder(graphborder);
         	contentPane.add(tmp);        	
	}
    
        public void AddToolBar()
        {
		toolBar = new JToolBar();
		toolBar.setFloatable(false);
				
		// toolbar on top of content pane
         	c.gridx = 0;
         	c.gridy = 0;
         	c.gridwidth=6;
         	c.gridheight=1;
         	c.weightx=1;
         	c.weighty=0;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.BOTH;
         	gridbag.setConstraints(toolBar, c);
         	contentPane.add(toolBar);
      	}

        public void AddCanvas()
        {
        	aqua = new ImagePanel(AlgUp);
         	aqua.setBackground(Color.white);
		aqua.setMaximumSize(new Dimension(2400, 2400));
                aqua.setMinimumSize(new Dimension(400, 400));
	        aqua.setPreferredSize(new Dimension(1000, 1000));
		aqua.setDoubleBuffered(true);
	        JScrollPane scrollPane = new JScrollPane(aqua);
                scrollPane.setMaximumSize(new Dimension(2400, 2400));
                scrollPane.setMinimumSize(new Dimension(400, 400));
	        scrollPane.setPreferredSize(new Dimension(1000, 1000));
			 
		TitledBorder graphborder= BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "GRAPH");

		scrollPane.setBorder(graphborder);
                c.gridx = 0;
         	c.gridy = 2;
         	c.gridwidth=9;
         	c.gridheight=6;
         	c.weightx=1.1;
         	c.weighty=1.1;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.BOTH;
		JPanel tmp=new JPanel(new GridLayout(1,1));
		tmp.add(scrollPane);
         	gridbag.setConstraints(tmp, c);
         	contentPane.add(tmp);          	
        }
        
        public void AddStatusBar()
        {
        	statusLabel=new JLabel("Ready to start simulation...");
        	
        	c.gridx = 0;
         	c.gridy = 8;
         	c.gridwidth=9;
         	c.gridheight=1;
         	c.weightx=1;
         	c.weighty=0;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.HORIZONTAL;
         	gridbag.setConstraints(statusLabel, c);
                contentPane.add(statusLabel);          	        	
        }
        
        public void SetupGUI()
        {
        	// assign gridbag-layout to contentpane
        	contentPane.setLayout(gridbag);
        	// add main menu items
        	AddMenuItems();
        	// add toolbar to top of contentpane
        	AddToolBar();
		// add stuff to toolbar
        	AddToolBarButtons();
        	// add Light and Speed sliders
        	AddSliders();
		// Options Checkboxes
		AddCBS();
		// the drawing area
        	AddCanvas();
		// and finally the status bar (simple panel)
        	AddStatusBar();
        }
		
	public algen() 
	{
        	addWindowListener(new WindowAdapter() 
        		{
            			public void windowClosing(WindowEvent e) 
            			{
        				System.exit(0);		
            			}
        		});

        	grayMenuBar = new JMenuBar();
        	grayMenuBar.setOpaque(true);
        	grayMenuBar.setPreferredSize(new Dimension(200, 20));

		SetupGUI();

		timer = new Timer(SimulationDelay*10, new ActionListener() {
		    public void actionPerformed(ActionEvent evt) {
			x++;
			y++;
			aqua.paintAlge(x,y); 
		    }    
		});
		
        	setJMenuBar(grayMenuBar);
		
        	timer.setCoalesce(false);
		
        }

        public static void main(String s[])
	{
	        SettingsDialog sdlg = new SettingsDialog();
		sdlg.setTitle("Settings dialog");
		sdlg.setVisible(true);
		sdlg.setSize(500,350);
		sdlg.setResizable(true);
		sdlg.pack();
		   
	         algen window = new algen();
		 window.setTitle("ALGAE Simulation");
		 window.setResizable(true);
		 window.setSize(800,600);
		 window.setVisible(true);		
        }

        public void ChangeStatusBar(String s)
        {
	        statusLabel.setText(s);
	}
       
        class SliderListener implements ChangeListener {
	    public void stateChanged(ChangeEvent e) {
		JSlider source = (JSlider)e.getSource();
		if ((source==SpeedSlider))
		{
		    int fps=(int)source.getValue();
		    SimulationDelay=fps;		    
 		    timer.setDelay(fps*10);
 		    System.out.println("SimulationDelay="+SimulationDelay);			
		}
	    }
	}
}

